Release tk8.0.5jp1.7 Nov 27, 1999

    (bug fix) Now tk80jp.dll and wish80jp.exe have proper
    version/codepage infomations. (Win)

    (bug fix) PostScript output in canvas widget now can generate
    proper stippled Kanji text. (UNIX/Win)

    (bug fix) More than one %A in bind script didn't work properly.
    (UNIX)

    (bug fix) {PreeditPosition StatusArea} conversion mode (AKA
    "over-the-spot") hadn't work properly from when the "on-the-spot"
    style were implemented. I enbug'd. (UNIX)

    (new feature) Better support of IM server using TCP transport
    other than X transport, like Xwnmo. FYI, the X transport was used
    in Ximp, the TCP transport was used in Xsi. (UNIX)

    (feature change) If XMODIFIERS environmental variable is set to
    "@im=none", Tk won't use XIM protocol, use kinput protocol
    instead. (UNIX)

Release tk8.0.5jp1.6 May 16, 1999

    (new feature) Now Tk can "on-the-spot conversion" via XIM
    protocol. (UNIX)

    (bug fix) Spell miss in tkKinsoku.c. (UNIX)

    (bug fix) Control character was not displayed at all in all widget.
    (UNIX)

Release tk8.0.5jp1.5fix1 Apr 10, 1999

    (new contents) Now this kit includes Japanized version of the
    "Widget tour". Special thanks to Mr. Atsushi Nemoto.

    (bug fix) Stopping direct-concatenation of $tk_library and file
    name to be sourced for operand of source command in tk.tcl.
    (UNIX/Win)

    (bug fix) Setting failsafe font caused memory leaks. (UNIX/Win)

    (feature change) Postions of underline and overstrike get better
    now. (UNIX)

    (bug fix) Initiating kanji conversion session between kinput2 via
    kinput protocol caused core dump on 64 bit word machines.

    (feature change) Now changing attributes of a compound font
    doesn't affect attributites of descendant fonts of the compound
    font. (UNIX/Win) (POTENTIAL INCOMPATIBILITY)

    (feature change) Now Tk checks type of returned selection to
    determine the returnd type is REALLY COMPOUND_TEXT. (UNIX)

    (new feature) Now kinsoku management works on any widgets that has
    capability to display text. (UNIX/Win)

    (bug fix) Line-end kinsoku management didn't work
    properly. (UNIX/Win)

Release tk8.0.5jp1.5 Mar 15, 1999

Confidential release tk8.0.5jp 1.5a Mar 12, 1999

    (new release) Modified for tk8.0.5.

    (feature change) For compatibility to original, Now tk DOESN'T
    refer DPI information to find a font. Thus, some font test must be
    failed as same as original. (UNIX)
    (POTENTIAL INCOMAPTIBILITY)

    (bug fix) Avoiding wired behavior when using /usr/openwin/bin/Xsun
    on Solaris 2.x. This X server ALSO returns BOGUS XLFD via
    XGetAtomName(XGetFontProperty(XA_FONT)). (UNIX)

    (bug fix) Related avobe, now tk finds a font property name SOMEHOW
    EVEN IF XGetFontProperty(XA_FONT) for the font fails. (UNIX)
    (POTENTIAL INCOMAPTIBILITY)

    (performance tuning) Text drawing by any widgets get little bit
    faster (approximately 5%). In some case, It is faster than
    original :^) (UNIX)

    (new feature) Now tk can "kinsoku" management in Text widget. If a
    user specify -wrap word mode, Text widget refers kinsoku character
    database managed by kinsoku command. The user can add/delete/show
    kinsoku character database. (UNIX/Win)

Release tk8.0.4jp1.4 Feb 12, 1999

    (new release) Many bug fixes. And from now the Windows version is
    called as stable 8.0jp release.

    (new feature) Now canvas PS output can handle hankaku
    kana. (UNIX/Win)

    (feature change) 'Cut & Paste' and clipboard handling robustness
    is increased. (UNIX/Win)

    (bug fix) Menu accelerator didn't work at all if the menu have
    kanji string entries. (UNIX/Win)

    (bug fix) entry/text binding that use clipboard/selection lost
    data containing kanji strings. (UNIX/Win)

    (bug fix) Even if a TEXT selection conversion request can be
    accepted successfuly, Tk returned an answer as TEXT. According
    to ICCCM, reply for TEXT coversion request must be one of
    STRING/COMPOUND_TEXT/C_STRING. (UNIX)

Confidential release tk8.0.4jp1.4a Jan 31, 1999

    (new feature) Compound font support in Windows. (Win)

    (bug fix) Now canvas refer failsafe font when PostScript
    generation. (UNIX/Win)

    (bug fix) Full overhauling of failsafe font. Now failsafe font can
    be specified by display using "font failsafe ?-displayof? ?path? 
    ?nativefont?" command. (UNIX/Win)

    (bug fix) Key board focus was completely lost when a window using
    XIM is taken the focus by other toplevel(s). (UNIX)

Release tk8.0.4jp1.3 Dec 18, 1998

    (new release) Windows platform is still in beta state, but it
    seems to work well.

Confidential Release tk8.0.4jp1.3a Dec 5, 1998

    (new feature) Merging Windows platform patch contributed by
    Mr. Atsushi Nemoto. Thanks a LOT! Cool man!

    (bug fix) Completely forgot to hard code prolog.ps into
    tkCanvPs.c. And replace eucfont routine to fixeucfont-1.2,
    invented by Mr. Norio Katayama. Thanks a LOT :)

Release tcl8.0.4jp1.2 Nov 28, 1998

    (new release) Modified for Tk8.0.4

Release tk8.0.3jp1.1-fix1 Oct 16, 1998

    (bug fix) Entry binding didn't work properly in XIM session.

    (bug fix) Widget path name that have kanji could not be parsed
    when internal kanji code is JIS.

Release tk8.0.3jp1.1 Sep 11, 1998

    (new release) Modified for Tk8.0.3

    (bug fix) MANY fixes around XIM. Thanks for everyone who send me
    bug reports!

    (feature change) Font loading algorithm is changed. Now foundry
    information of XLFD can be specified when named font
    creation. font command has "-foundry" option. If the font foundry
    is specified, and pointsize is not zero, Tk tries to load the font
    as exactly as the XLFD pattern specified. In this case, Tk also
    use DPI information. This is efficient when using rather slow,
    legacy X server(means for X server that has slow
    LoadFonts/ListFonts protocol handling routine).
    (No problem when 'make test', but mayhaps has POTENTIAL
     INCOMPATIBILITY, depend on X server or X Font search path)

    (new feature) Font cache. To find a font, Now tk8.0jp doesn't call
    XListFonts() as frequently as older version is doing. Furthermore,
    fonts loaded by font command are cached for very next text
    drawing. These cached fonts can be unloaded by calling "font
    cache clear" command. Furthermore, by configure option,
    XLoadQueryFont() and XListFonts() will be replaced to Tk's
    internal function that referrence cached font. This improve
    performance and resource usage of XCreateFontSet(), helpfull
    for XIM session. This replacement is ONLY available for XFree86 3.3.x.

Release tk8.0p2jp1.1b0 Jul 16, 1998

    (bug fix) Tk_WTextWidth() was called with non-terminated wchar
    string and -1 length in tkUnixMenu.c.

    (bug fix) TK_CONFIG_END had a different definition from the
    original, again.

Confidential release tk8.0p2jp1.1b0 Jun 13, 1998

    (new feature) better XIM support. Tk8.0jp now can use XIM
    protocol with various input style (POTENTIAL INCOMPATIBILITY).

Release tk8.0p2jp1.0 May 18, 1998

    (bug fix) Adding strict status checking for kinput2 session to
    avoid error when re-creation of same named widget.

    (bug fix) *tkDefaultFont resource in X resource database didn't
    work at all.

    (support) Adding X-TT server support code to avoid XLFD bug in the
    server.

Release tk8.0p2jpb3 Feb 23, 1998

    (feature change) Now font option "-pointadjust" specify (ascii
    point size)/(kanji point size).

    (bug fix) Descendant ascii font of a compound font was always
    resized to descendant kanji font of the compound font.

Release tk8.0p2jpb2 Jan 23, 1998

    (bug fix) Some keyboard binds didn't work correctly in kinput2
    session.

    (bug fix) kanjiInput command didn't pass the font attribute to
    kinput2.

    (bug fix) "font configure" command for compound font doesn't work
    correctly.

    (bug fix) "font create" command can't handle options after
    "-compound" option.

    (feature change) "font create" command now can create named fonts
    starting with "-" (POTENTIAL INCOMPATIBILITY).

    (new feature) "font failsafe" command was added for 4.xjp backword
    compatibility.

    (new feature) "tkDefineFont" and "tkDefaultFont" resource in X
    resource database are referenced at start up.

Release tk8.0p2jpb1 Dec 25, 1997

    (bug fix) Fixed core dump bug when initiating kinput2 session on
    Solaris 2.x.

    (bug fix) Fixed core dump bug when getting X server default font.

Release tk8.0p2jpb0 Nov 28, 1997

    (new release) Modified for Tk8.0p2.

Release tk8.0p1jpb0 Nov 21, 1997

    (new release) Modified for Tk8.0p1.

Confidential Release tk8.0jpa0 Aug 22, 1997

    (new release) Modified for the Tk8.0.

Confidential Release tk8.0b1jp Jun 25, 1997

    (new release) Modified for the Tk8.0b1.

    (feature change) No more -kanjifont option (MAJOR INCOMPATIBILITY).

    (new feature) Supporting the compound font mechanism by enhancing
    original named font creation method.

Release tk4.2jp, November 24, 1996

    (new release) Modified for the Tk4.2.

    (new release) Modified for the Tk4.1p1.

    (feature change) Eliminated exported global variables (they don't work with
    Windows DLLs).  The arrays of Kanji Encode/Decode functions (Tcl_KanjiEncode
    and Tcl_KanjiDecode) are replaced with C functions (Tcl_KanjiEncode() and
    Tcl_KanjiDecode()).

    (bug fix) Bug fixes for Windows version (by Mr. Hiroaki NAKAMURA).

Release tk4.1jp_alpha, April 25, 1996

    (new release) Modified for the Tk4.1.

    (new feature) A set of patches for Windows is contributed from
    Mr. Hiroaki NAKAMURA.

    (new release) Modified for the Tk4.1b3.

    (new release) Modified for the Tk4.1b1.

    (new release) Modified for the Tk4.1a2.

Release tk4.0p3jp, December 11, 1995

    (bug fix) Fixed a bug in 'library/prolog.ps'.  Now you can generate a
    PostScript including kanji characters.

    (bug fix) Fixed a bug in tag priority of Text Widgets.  If you specify
    a kanji font with a tag, and then specify a ascii font with another tag,
    kanji strings are displayed with the default kanji font.

Release tk4.0jp, September 25, 1995

    (bug fix) Fixed a bug in TkTextCharLayoutProc.  'ciPtr' was accidentally
    allocated twice.

    (bug fix) Fixed a bug in ConfigureScale.  'gcValues.foreground' was
    accidentally unitialized for 'scalePtr->troughGC'.

    (new features) For window managers that can handle compound text, wm command
    now convert a string from STRING to COMPOUND_TEXT if the string contains
    kanji characters.  Mr. Motonori Hirano (m-hirano@sra.co.jp) contributed this
    patch.

    (bug fix) Fixed a bug in the insert option of text widgets.  Even if you
    specify a tag for some attributes of text, sometimes it doesn't affect on
    its appearence.

    (bug fix) Fixed a bug in tkWStr.c  Use memset insted of bzero.

    (bug fix) Fixed a bug in tkMenu.c.  Mismatched #endif remains a trace on a
    variable which does not exist.

Release tk4.0jp-beta, August 1, 1995

    (bug fix) Fixed bug in TkWSTextExtents. The initial value of lbearing should
    not be 0.

    (new release) Modified some test suites which generate errors according to
    the kanji font.

Release tk4.0jp-alpha, July 12, 1995

    (new release) Lots of modifications according to the new release.

Release tk3.6jp-update3, May 24, 1995

    (bug fix) Handling of -font/-kanjifont options for text tags were incorrect.
    the results of Tk_GetFontStruct() cannot be simply copied,
    because of the reference counting.

    (bug fix) Tk_GetFontStruct takes Tk_Uid, not just "char *" for the fontname.
    This bug causes an unnecessary XLoadQueryFont every time kanjiInput start/
    attribute command is invoked.

    (bug fix) Fixed bug in EntryFetchSelection to free memory properly.

    (bug fix) Fixed a bug in library/kinput.tcl. If font name contains blank
    characters, over-the-spot type input causes some warning messages.

    (bug fix) When the kana-kanji converion is taking place, tk doesn't restore
    the window field of forwarded key events, causing bind command to be confused.

Release tk3.6jp-update2, August 25, 1994

    (bug fix) The declaration of checkProtocol() has been taken out of a
    function block.

Release tk3.6jp-update1, February 14, 1994

    (bug fix) Fixed bug in tkKinput2.c for systems (some 64bit CPUs including
    DEC/Alpha) where 'sizeof(long)' > 4.    

    (bug fix) Fixed 'xypos' widget command in tkTextDisp.c to handle folded
    long lines correctly.

    (bug fix) TK_CONFIG_END had a different definition from the original.
    This might cause some troubles when the user mixes the Japanization and
    other extensions.

    (bug fix) Moved 'tkWStr.h' out of 'tk.h' since 'tk.h' is installed to the
    system directory but 'tkWStr.h' is not.

    (bug fix) Eliminated every 'bstring' functions.

Release tk3.6jp, December 7, 1993

    (bug fix) Canvases couldn't generate correct PS outputs when the kanji font
    doesn't have XLFD name.

    (bug fix) The caching of kanji fonts was incorrect.

    (new feature) Modified tkFont.c and tkWStr.c to handle ISO Latin1 encodings.

    (new feature) Modified tkKinput2.c to forward the key event on the widget to
    the input server (i.e. kinput2).  Thus the user doesn't have to move the
    mouse cursor to the window of the input server.

    (bug fix) When several widgets require kanji input at a time, the input
    server sent the conversion result to the wrong widget.

    (configuration change) Eliminated 'ctype-fix.h': this file was introduced
    to fix the bug in the original Tcl/Tk.  Since the bug fix is incorporated
    into the original source code, this local bug fix is no longer needed.

    (bug fix) Fixed bug in tkKinput2.c to initialize the number of specified
    attributes.

    (bug fix) Clone interpreter needs current position to be set before
    executing 'cshow'.

Release tk3.2jp-update1, August 26, 1993

Release tk3.2jp, July 9, 1993
